﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub
'Turn the flash on - Torch mode active
Public Sub TurnFlashOn()

Dim turnOn As Boolean = True
nativeMe.RunMethod("TurnFlashOn",Array(turnOn))

End Sub
'Turn the flash on - Torch mode active
Public Sub TurnFlashOff()

Dim dummy As Int  = 1
nativeMe.RunMethod("TurnFlashOff",Array(dummy))

End Sub



#If java

import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.util.Log;
import android.content.Context;
import android.os.Build;

import java.io.IOException;
import java.util.List;

    static Camera m_Camera; 
    static Parameters cameraParameters; 

    
/**
*Turn the camera flash ON (in TORCH MODE)
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.CAMERA")
*/
    public void TurnFlashOn(boolean turnOn)
    {
               String flashMode; 
               flashMode = "";
               try
               {
                        m_Camera = Camera.open();
                        cameraParameters = m_Camera.getParameters();
                        List<String> flashModes = cameraParameters.getSupportedFlashModes();
                        flashMode = cameraParameters.getFlashMode();

                        if(turnOn == true)
                        {
                                if (!Parameters.FLASH_MODE_TORCH.equals(flashMode)) 
                                {
                                        // Turn on the flash
                                        if (flashModes.contains(Parameters.FLASH_MODE_TORCH)) 
                                        {
                                                cameraParameters.setFlashMode(Parameters.FLASH_MODE_ON); 
                                                cameraParameters.setFocusMode(Parameters.FOCUS_MODE_INFINITY);
                                                cameraParameters.setFlashMode(Parameters.FLASH_MODE_TORCH);
                                                m_Camera.setParameters(cameraParameters);
                                                m_Camera.startPreview();
                                                flashMode = cameraParameters.getFlashMode();
                                        }
                                }
                        }
                        else
                        {
                                if (!Parameters.FLASH_MODE_OFF.equals(flashMode))
                                {
                                        // Turn off the flash
                                        if (flashModes.contains(Parameters.FLASH_MODE_OFF))
                                        {
                                          cameraParameters.setFlashMode(Parameters.FLASH_MODE_OFF);
                                          m_Camera.setParameters(cameraParameters);
                                        } else
                                        {
                                            flashMode = "Camera Flash - FLASH_MODE_OFF not supported";
                                        }

                                }
                        }
                }
                  catch (RuntimeException e) 
                {
                     flashMode = "Camera Flash - Camera failed: " + e.getMessage();
                }
//                return flashMode;
    }

/**
*Turn OFF the camera flash (that is in TORCH MODE)
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.CAMERA")
*/
    public void TurnFlashOff(int dummy)
    {
                StringBuilder result = new StringBuilder(1000);
                String flashMode;
                flashMode = "";
                TurnFlashOn(false);
                if (m_Camera != null)
                {
                        m_Camera.stopPreview();
                        m_Camera.release();
                        m_Camera = null;
                        flashMode = "Camera Flash - Flash Turned Off";
                        result.append("VERSION.SDK_INT=").append(Build.VERSION.SDK_INT).append('\n');
                        result.append("MODEL=").append(Build.MODEL).append('\n');
                }
//                return (flashMode + " " + result.toString());
    }

#End If